#include <math.h>
#include <iostream>

#include "./common.h"
#include "./types.h"
#include "./geom.h"
#include "./texture.h"

using namespace std;

// #define SIN_LEN 7.64

GLfloat sin_len(GLfloat h, GLfloat f) {
  GLfloat t = 0;
  for (GLfloat v = 0; v < 1; v+=h) {
    const GLfloat theta1 = v * M_PI * 2;
    const GLfloat theta2 = (v+h) * M_PI * 2;
    const GLfloat d = sqrt(pow(f*sin(theta2)-f*sin(theta1), 2) +
                           pow(theta2 - theta1, 2));
    t += d;
  }
  return t;
}

void Init();

GLuint* texture_ids;
extern GLfloat window_aspect;
extern int rot_theta;
extern int rot_phi;
extern GLfloat zoom;

void Setup() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(0, 0, 200,
            0, 0, 0,
            0, 1, 0);
  glRotatef(rot_theta, 0, 1, 0);
  glRotatef(rot_phi, 1, 0, 0);

  glDisable(GL_LIGHTING);
  glLineWidth(4);
  DrawAxis();
  // glEnable(GL_LIGHTING);
}

void Display() {
}

void Init1() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  const bool wrap = false;
  LoadTexture("lion.jpg", texture_ids[0], wrap);
}
void Display1() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  glTexCoord2d(0, 1);   glVertex3f(-0.5, -0.5, 0);
  glTexCoord2d(1, 1);   glVertex3f(0.5, -0.5, 0);
  glTexCoord2d(1, 0);   glVertex3f(0.5, 0.5, 0);
  glTexCoord2d(0, 0);   glVertex3f(-0.5, 0.5, 0);

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init2() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  const bool wrap = false;
  LoadTexture("lion.jpg", texture_ids[0], wrap);
}
void Display2() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a lion
  //  B) 2 lions
  //  C) 1/2 lion
  //  D) none of the above
  glTexCoord2d(0, 1);   glVertex3f(-0.5, -0.5, 0);
  // x changed to 2
  glTexCoord2d(2, 1);   glVertex3f(0.5, -0.5, 0);
  // x changed to 2
  glTexCoord2d(2, 0);   glVertex3f(0.5, 0.5, 0);
  glTexCoord2d(0, 0);   glVertex3f(-0.5, 0.5, 0);

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init3() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  // wrap changed to true
  const bool wrap = true;
  LoadTexture("lion.jpg", texture_ids[0], wrap);
}
void Display3() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a lion
  //  B) 2 lions
  //  C) 1/2 lion
  //  D) none of the above
  glTexCoord2d(0, 1);   glVertex3f(-0.5, -0.5, 0);
  glTexCoord2d(2, 1);   glVertex3f(0.5, -0.5, 0);
  glTexCoord2d(2, 0);   glVertex3f(0.5, 0.5, 0);
  glTexCoord2d(0, 0);   glVertex3f(-0.5, 0.5, 0);

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init4() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  const bool wrap = true;
  LoadTexture("lion.jpg", texture_ids[0], wrap);
}
void Display4() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a lion
  //  B) 2 lions
  //  C) 1/2 lion
  //  D) none of the above
  glTexCoord2d(0, 1);     glVertex3f(-0.5, -0.5, 0);
  // changed to 0.5
  glTexCoord2d(0.5, 1);   glVertex3f(0.5, -0.5, 0);
  // changed to 1
  glTexCoord2d(1, 0);     glVertex3f(0.5, 0.5, 0);
  glTexCoord2d(0, 0);     glVertex3f(-0.5, 0.5, 0);

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init5() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  const bool wrap = true;
  LoadTexture("lion.jpg", texture_ids[0], wrap);
}
void Display5() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a lion
  //  B) 2 lions
  //  C) 1/2 lion
  //  D) none of the above

  // texture coordinates changed
  glTexCoord2d(0, 2);   glVertex3f(-0.5, -0.5, 0);
  glTexCoord2d(2, 2);   glVertex3f(0.5, -0.5, 0);
  glTexCoord2d(2, 0);   glVertex3f(0.5, 0.5, 0);
  glTexCoord2d(0, 0);   glVertex3f(-0.5, 0.5, 0);

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init6() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  const bool wrap = true;
  LoadTexture("lion.jpg", texture_ids[0], wrap);
}
void Display6() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a lion
  //  B) 2 lions
  //  C) 1/2 lion
  //  D) none of the above
  glTexCoord2d(0, 1);   glVertex3f(-0.5, -0.5, 0);
                        // x changed to 0
  glTexCoord2d(1, 1);   glVertex3f(0, -0.5, 0);
  glTexCoord2d(1, 0);   glVertex3f(0.5, 0.5, 0);
  glTexCoord2d(0, 0);   glVertex3f(-0.5, 0.5, 0);

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init7() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  const bool wrap = true;
  LoadTexture("lion.jpg", texture_ids[0], wrap);
}
void Display7() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  // this changed
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
  glColor3f(0, 1, 0);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a green lion
  //  B) a blue lion
  //  C) a regular lion
  //  D) none of the above

  // texture coordinates changed
  glTexCoord2d(0, 1);   glVertex3f(-0.5, -0.5, 0);
  glTexCoord2d(1, 1);   glVertex3f(0.5, -0.5, 0);
  glTexCoord2d(1, 0);   glVertex3f(0.5, 0.5, 0);
  glTexCoord2d(0, 0);   glVertex3f(-0.5, 0.5, 0);

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init8() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  const bool wrap = true;
  LoadTexture("lion.jpg", texture_ids[0], wrap);
}
void Display8() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  // this changed
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  glColor3f(0, 1, 0);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a green lion
  //  B) a blue lion
  //  C) a regular lion
  //  D) none of the above

  // texture coordinates changed
  glTexCoord2d(0, 1);   glVertex3f(-0.5, -0.5, 0);
  glTexCoord2d(1, 1);   glVertex3f(0.5, -0.5, 0);
  glTexCoord2d(1, 0);   glVertex3f(0.5, 0.5, 0);
  glTexCoord2d(0, 0);   glVertex3f(-0.5, 0.5, 0);

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init9() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  LoadTexture("lion.jpg", texture_ids[0], false);
}
void Display9() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) 1 lion
  //  B) 4 lions
  //  C) 1/4 lion
  //  D) none of the above
  const GLfloat h = 0.5;
  for (GLfloat u = 0; u < 1; u+=h) {
    for (GLfloat v = 0; v < 1; v+=h) {
      const GLfloat x1 = u-0.5;
      const GLfloat x2 = (u+h)-0.5;
      const GLfloat y1 = v-0.5;
      const GLfloat y2 = (v+h)-0.5;
      const GLfloat z1 = 0;
      const GLfloat z2 = 0;
      const GLfloat s1 = 0;
      const GLfloat s2 = 1;
      const GLfloat t1 = 1;
      const GLfloat t2 = 0;

      Vec2f vt[] = { Vec2f::makeVec(s1, t1),
                     Vec2f::makeVec(s2, t1),
                     Vec2f::makeVec(s2, t2),
                     Vec2f::makeVec(s1, t2) };
      Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
                    Vec3f::makeVec(x2, y1, z1),
                    Vec3f::makeVec(x2, y2, z2),
                    Vec3f::makeVec(x1, y2, z2) };
      for (int i = 0; i < 4; ++i) {
        glTexCoord2fv(vt[i]);
        glVertex3fv(v[i]);
      }
    }
  }

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init10() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  LoadTexture("lion.jpg", texture_ids[0], false);
}
void Display10() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) 1 lion
  //  B) 4 lions
  //  C) 1/4 lion
  //  D) none of the above
  const GLfloat h = 0.5;
  for (GLfloat u = 0; u < 1; u+=h) {
    for (GLfloat v = 0; v < 1; v+=h) {
      const GLfloat x1 = u-0.5;
      const GLfloat x2 = (u+h)-0.5;
      const GLfloat y1 = v-0.5;
      const GLfloat y2 = (v+h)-0.5;
      const GLfloat z1 = 0;
      const GLfloat z2 = 0;
      // these lines changed
      const GLfloat s1 = u;
      const GLfloat s2 = u+h;
      const GLfloat t1 = 1-v;
      const GLfloat t2 = 1-(v+h);

      Vec2f vt[] = { Vec2f::makeVec(s1, t1),
                     Vec2f::makeVec(s2, t1),
                     Vec2f::makeVec(s2, t2),
                     Vec2f::makeVec(s1, t2) };
      Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
                    Vec3f::makeVec(x2, y1, z1),
                    Vec3f::makeVec(x2, y2, z2),
                    Vec3f::makeVec(x1, y2, z2) };
      for (int i = 0; i < 4; ++i) {
        glTexCoord2fv(vt[i]);
        glVertex3fv(v[i]);
      }
    }
  }

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init11() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  LoadTexture("lion.jpg", texture_ids[0], false);
}
void Display11() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) 1 lion
  //  B) 4 lions
  //  C) 1/4 lion
  //  D) none of the above

  // this line changed
  const GLfloat h = 0.02;
  for (GLfloat u = 0; u < 1; u+=h) {
    for (GLfloat v = 0; v < 1; v+=h) {
      const GLfloat x1 = u-0.5;
      const GLfloat x2 = (u+h)-0.5;
      const GLfloat y1 = v-0.5;
      const GLfloat y2 = (v+h)-0.5;
      const GLfloat z1 = 0;
      const GLfloat z2 = 0;
      const GLfloat s1 = u;
      const GLfloat s2 = u+h;
      const GLfloat t1 = 1-v;
      const GLfloat t2 = 1-(v+h);

      Vec2f vt[] = { Vec2f::makeVec(s1, t1),
                     Vec2f::makeVec(s2, t1),
                     Vec2f::makeVec(s2, t2),
                     Vec2f::makeVec(s1, t2) };
      Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
                    Vec3f::makeVec(x2, y1, z1),
                    Vec3f::makeVec(x2, y2, z2),
                    Vec3f::makeVec(x1, y2, z2) };
      for (int i = 0; i < 4; ++i) {
        glTexCoord2fv(vt[i]);
        glVertex3fv(v[i]);
      }
    }
  }

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init12() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  LoadTexture("lion.jpg", texture_ids[0], false);
}
void Display12() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a normal lion
  //  B) a fun house lion
  //  C) a green lion
  //  D) none of the above
  const GLfloat h = 0.02;
  const GLfloat f = 0.4;
  for (GLfloat u = 0; u < 1; u+=h) {
    for (GLfloat v = 0; v < 1; v+=h) {
      const GLfloat x1 = u-0.5;
      const GLfloat x2 = (u+h)-0.5;
      const GLfloat y1 = v-0.5;
      const GLfloat y2 = (v+h)-0.5;
      // these lines changed
      const GLfloat theta1 = v * 2 * M_PI;
      const GLfloat theta2 = (v+h) * 2 * M_PI;
      const GLfloat z1 = f*sin(theta1);
      const GLfloat z2 = f*sin(theta2);

      const GLfloat s1 = u;
      const GLfloat s2 = u+h;
      const GLfloat t1 = 1-v;
      const GLfloat t2 = 1-(v+h);

      Vec2f vt[] = { Vec2f::makeVec(s1, t1),
                     Vec2f::makeVec(s2, t1),
                     Vec2f::makeVec(s2, t2),
                     Vec2f::makeVec(s1, t2) };
      Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
                    Vec3f::makeVec(x2, y1, z1),
                    Vec3f::makeVec(x2, y2, z2),
                    Vec3f::makeVec(x1, y2, z2) };
      for (int i = 0; i < 4; ++i) {
        glTexCoord2fv(vt[i]);
        glVertex3fv(v[i]);
      }
    }
  }

  glEnd();

  glFlush();
  glutSwapBuffers();
}

void Init13() {
  Init();
  texture_ids = new GLuint[1];
  glGenTextures(1, texture_ids);
  LoadTexture("lion.jpg", texture_ids[0], false);
}
void Display13() {
  Setup();

  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);

  // What is drawn?
  //  A) a normal lion
  //  B) a fun house lion
  //  C) a green lion
  //  D) none of the above
  const GLfloat h = 0.02;
  // f increased to 10
  const GLfloat f = 10;
  // compute the total length of the sin curve
  const GLfloat SIN_LEN = sin_len(h, f);
  for (GLfloat u = 0; u < 1; u+=h) {
    // Now keep a current t
    GLfloat t = 0;
    for (GLfloat v = 0; v < 1; v+=h) {
      const GLfloat x1 = u-0.5;
      const GLfloat x2 = (u+h)-0.5;
      const GLfloat y1 = v-0.5;
      const GLfloat y2 = (v+h)-0.5;
      const GLfloat theta1 = v * 2 * M_PI;
      const GLfloat theta2 = (v+h) * 2 * M_PI;
      const GLfloat z1 = f*sin(theta1);
      const GLfloat z2 = f*sin(theta2);
      const GLfloat s1 = u;
      const GLfloat s2 = u+h;

      // These lines changed
      const GLfloat d = sqrt(pow(z2-z1, 2) + pow(theta2-theta1, 2)) / SIN_LEN;
      const GLfloat t1 = 1-t;
      const GLfloat t2 = 1-(t+d);
      t += d;

      Vec2f vt[] = { Vec2f::makeVec(s1, t1),
                     Vec2f::makeVec(s2, t1),
                     Vec2f::makeVec(s2, t2),
                     Vec2f::makeVec(s1, t2) };
      Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
                    Vec3f::makeVec(x2, y1, z1),
                    Vec3f::makeVec(x2, y2, z2),
                    Vec3f::makeVec(x1, y2, z2) };
      for (int i = 0; i < 4; ++i) {
        glTexCoord2fv(vt[i]);
        glVertex3fv(v[i]);
      }
    }
  }

  glEnd();

  glFlush();
  glutSwapBuffers();
}

// void Init9() {
//   Init();
//   texture_ids = new GLuint[1];
//   glGenTextures(1, texture_ids);
//   LoadTexture("lion.jpg", texture_ids[0], false);
// }
// void Display9() {
//   Setup();

//   glEnable(GL_TEXTURE_2D);
//   glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

//   glColor3f(.5, 1, .5);
//   glBegin(GL_QUADS);

//   const GLfloat h = 0.02;
//   const GLfloat f = 1;
//   const GLfloat SIN_LEN = sin_len(h, f);
//   for (GLfloat u = 0; u < 1; u+=h) {
//     GLfloat t = 0;
//     for (GLfloat v = 0; v < 1; v+=h) {
//       const GLfloat theta1 = v * 2 * M_PI;
//       const GLfloat theta2 = (v+h) * 2 * M_PI;
//       const GLfloat x1 = u-0.5;
//       const GLfloat x2 = (u+h)-0.5;
//       const GLfloat y1 = v-0.5;
//       const GLfloat y2 = (v+h)-0.5;
//       const GLfloat z1 = f*sin(theta1);
//       const GLfloat z2 = f*sin(theta2);
//       const GLfloat s1 = u;
//       const GLfloat s2 = u+h;
//       const GLfloat d = sqrt(pow(z2-z1, 2) + pow(theta2-theta1, 2)) / SIN_LEN;
//       const GLfloat t1 = 1-v;
//       const GLfloat t2 = 1-(v+h);

//       t += d;

//       Vec2f vt[] = { Vec2f::makeVec(s1, t1),
//                      Vec2f::makeVec(s2, t1),
//                      Vec2f::makeVec(s2, t2),
//                      Vec2f::makeVec(s1, t2) };
//       Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
//                     Vec3f::makeVec(x2, y1, z1),
//                     Vec3f::makeVec(x2, y2, z2),
//                     Vec3f::makeVec(x1, y2, z2) };
//       for (int i = 0; i < 4; ++i) {
//         glTexCoord2fv(vt[i]);
//         glVertex3fv(v[i]);
//       }
//     }
//   }

//   glEnd();

//   // What if we change wrap?
//   // Twiddle s, t
//   // Can we tile?
//   glFlush();
//   glutSwapBuffers();
// }

// void Init7() {
//   Init();
//   texture_ids = new GLuint[1];
//   glGenTextures(1, texture_ids);
//   LoadTexture("lion.jpg", texture_ids[0], false);
// }
// void Display7() {
//   Setup();

//   glEnable(GL_TEXTURE_2D);
//   glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

//   glColor3f(.5, 1, .5);
//   glBegin(GL_QUADS);

//   const GLfloat h = 0.02;
//   const GLfloat f = 1;
//   const GLfloat SIN_LEN = sin_len(h, f);
//   for (GLfloat u = 0; u < 1; u+=h) {
//     GLfloat t = 0;
//     for (GLfloat v = 0; v < 1; v+=h) {
//       const GLfloat theta1 = v * 2 * M_PI;
//       const GLfloat theta2 = (v+h) * 2 * M_PI;
//       const GLfloat x1 = u-0.5;
//       const GLfloat x2 = (u+h)-0.5;
//       const GLfloat y1 = v-0.5;
//       const GLfloat y2 = (v+h)-0.5;
//       const GLfloat z1 = f*sin(theta1);
//       const GLfloat z2 = f*sin(theta2);
//       const GLfloat s1 = u;
//       const GLfloat s2 = u+h;
//       const GLfloat d = sqrt(pow(z2-z1, 2) + pow(theta2-theta1, 2)) / SIN_LEN;
//       const GLfloat t1 = 1-v;
//       const GLfloat t2 = 1-(v+h);

//       t += d;

//       Vec2f vt[] = { Vec2f::makeVec(s1, t1),
//                      Vec2f::makeVec(s2, t1),
//                      Vec2f::makeVec(s2, t2),
//                      Vec2f::makeVec(s1, t2) };
//       Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
//                     Vec3f::makeVec(x2, y1, z1),
//                     Vec3f::makeVec(x2, y2, z2),
//                     Vec3f::makeVec(x1, y2, z2) };
//       for (int i = 0; i < 4; ++i) {
//         glTexCoord2fv(vt[i]);
//         glVertex3fv(v[i]);
//       }
//     }
//   }

//   glEnd();

//   // What if we change wrap?
//   // Twiddle s, t
//   // Can we tile?
//   glFlush();
//   glutSwapBuffers();
// }

// void Init8() {
//   Init();
//   texture_ids = new GLuint[1];
//   glGenTextures(1, texture_ids);
//   LoadTexture("lion.jpg", texture_ids[0], false);
// }
// void Display8() {
//   Setup();

//   glEnable(GL_TEXTURE_2D);
//   glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

//   glColor3f(1, 1, 1);
//   glBegin(GL_QUADS);

//   const GLfloat h = 0.02;
//   const GLfloat f = 10;
//   const GLfloat SIN_LEN = sin_len(h, f);
//   for (GLfloat u = 0; u < 1; u+=h) {
//     GLfloat t = 0;
//     for (GLfloat v = 0; v < 1; v+=h) {
//       const GLfloat theta1 = v * 2 * M_PI;
//       const GLfloat theta2 = (v+h) * 2 * M_PI;
//       const GLfloat x1 = u-0.5;
//       const GLfloat x2 = (u+h)-0.5;
//       const GLfloat y1 = v-0.5;
//       const GLfloat y2 = (v+h)-0.5;
//       const GLfloat z1 = f*sin(theta1);
//       const GLfloat z2 = f*sin(theta2);
//       const GLfloat s1 = u;
//       const GLfloat s2 = u+h;
//       const GLfloat d = sqrt(pow(z2-z1, 2) + pow(theta2-theta1, 2)) / SIN_LEN;
//       const GLfloat t1 = 1-t;
//       const GLfloat t2 = 1-(t+d);

//       t += d;

//       Vec2f vt[] = { Vec2f::makeVec(s1, t1),
//                      Vec2f::makeVec(s2, t1),
//                      Vec2f::makeVec(s2, t2),
//                      Vec2f::makeVec(s1, t2) };
//       Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
//                     Vec3f::makeVec(x2, y1, z1),
//                     Vec3f::makeVec(x2, y2, z2),
//                     Vec3f::makeVec(x1, y2, z2) };
//       for (int i = 0; i < 4; ++i) {
//         glTexCoord2fv(vt[i]);
//         glVertex3fv(v[i]);
//       }
//     }
//   }

//   glEnd();

//   // What if we change wrap?
//   // Twiddle s, t
//   // Can we tile?
//   glFlush();
//   glutSwapBuffers();
// }

// void Init9() {
//   Init();
//   texture_ids = new GLuint[1];
//   glGenTextures(1, texture_ids);
//   LoadTexture("lion.jpg", texture_ids[0], false);
// }
// void Display9() {
//   Setup();

//   glEnable(GL_TEXTURE_2D);
//   glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

//   glColor3f(1, 1, 1);
//   glBegin(GL_QUADS);

//   GLfloat h = 0.02;
//   for (GLfloat u = 0; u < 1; u+=h) {
//     for (GLfloat v = 0; v < 1; v+=h) {
//       const GLfloat theta1 = v * M_PI * 2;
//       const GLfloat theta2 = (v+h) * M_PI * 2;
//       const GLfloat f = 1.0f;
//       const GLfloat s1 = u;
//       const GLfloat s2 = u+h;
//       const GLfloat t1 = 1-v;
//       const GLfloat t2 = 1-(v+h);
//       const GLfloat x1 = u-0.5;
//       const GLfloat x2 = (u+h)-0.5;
//       const GLfloat y1 = v-0.5;
//       const GLfloat y2 = (v+h)-0.5;
//       const GLfloat z1 = -f*sin(theta1);
//       const GLfloat z2 = -f*sin(theta2);
      
//       Vec2f vt[] = { Vec2f::makeVec(s1, t1),
//                      Vec2f::makeVec(s2, t1),
//                      Vec2f::makeVec(s2, t2),
//                      Vec2f::makeVec(s1, t2) };
//       Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
//                     Vec3f::makeVec(x2, y1, z1),
//                     Vec3f::makeVec(x2, y2, z2),
//                     Vec3f::makeVec(x1, y2, z2) };
//       for (int i = 0; i < 4; ++i) {
//         glTexCoord2fv(vt[i]);
//         glVertex3fv(v[i]);
//       }
//     }
//   }

//   glEnd();

//   // What if we change wrap?
//   // Twiddle s, t
//   // Can we tile?
//   glFlush();
//   glutSwapBuffers();
// }

// void Init10() {
//   Init();
//   texture_ids = new GLuint[1];
//   glGenTextures(1, texture_ids);
//   LoadTexture("lion.jpg", texture_ids[0], false);
// }
// void Display10() {
//   Setup();

//   glEnable(GL_TEXTURE_2D);
//   glBindTexture(GL_TEXTURE_2D, texture_ids[0]);

//   glColor3f(1, 1, 1);
//   glBegin(GL_QUADS);

//   const GLfloat h = 0.02;
//   const GLfloat f = 10.0f;
//   const GLfloat SIN_LEN = sin_len(h, f);
//   for (GLfloat u = 0; u < 1; u+=h) {
//     GLfloat t = 0;
//     for (GLfloat v = 0; v < 1; v+=h) {
//       const GLfloat theta1 = v * M_PI * 2;
//       const GLfloat theta2 = (v+h) * M_PI * 2;
//       const GLfloat s1 = u;
//       const GLfloat s2 = u+h;
//       const GLfloat d = sqrt(pow(f*sin(theta2)-f*sin(theta1), 2) +
//                                    pow(theta2 - theta1, 2));
//       const GLfloat t1 = 1-t/SIN_LEN;
//       const GLfloat t2 = 1-(t+d)/SIN_LEN;
//       t += d;
//       cout << d << endl;
//       const GLfloat x1 = u-0.5;
//       const GLfloat x2 = (u+h)-0.5;
//       const GLfloat y1 = v-0.5;
//       const GLfloat y2 = (v+h)-0.5;
//       const GLfloat z1 = -f*sin(theta1);
//       const GLfloat z2 = -f*sin(theta2);
      
//       Vec2f vt[] = { Vec2f::makeVec(s1, t1),
//                      Vec2f::makeVec(s2, t1),
//                      Vec2f::makeVec(s2, t2),
//                      Vec2f::makeVec(s1, t2) };
//       Vec3f v[] = { Vec3f::makeVec(x1, y1, z1),
//                     Vec3f::makeVec(x2, y1, z1),
//                     Vec3f::makeVec(x2, y2, z2),
//                     Vec3f::makeVec(x1, y2, z2) };
//       for (int i = 0; i < 4; ++i) {
//         glTexCoord2fv(vt[i]);
//         glVertex3fv(v[i]);
//       }
//     }
//   }

//   glEnd();

//   // What if we change wrap?
//   // Twiddle s, t
//   // Can we tile?
//   glFlush();
//   glutSwapBuffers();
// }

